#Airbridge structure, after first succesful construction of air bridges using previous script
#previous airbridges have spoon like base. Will try to correct this by adding clearance to via.
#model  for testing dose
require_relative 'SK_library'

app = RBA::Application.instance
mw = app.main_window

#  create a new layout 
mw.create_layout( 0 )
view = mw.current_view

#  create a new layer in that layout
layout = view.cellview( 0 ).layout 
linfo = RBA::LayerInfo.new ("Silicon")
silicon_layer = layout.insert_layer( linfo )

linfo = RBA::LayerInfo.new ("SAW")
saw_layer = layout.insert_layer( linfo )

#dummy cell is for all bridge holes
linfo = RBA::LayerInfo.new ("BRIDGELAYER")
bridge_layer = layout.insert_layer( linfo )
linfo = RBA::LayerInfo.new ("VIAS")
dimple_layer = layout.insert_layer( linfo )

bridge_cell = layout.create_cell("BRIDGE")
dummy_cell= layout.create_cell("DUMMY")

layout.dbu = 0.001
chip_length=6200000

cell1 = layout.create_cell("TOP")

saw_cell=layout.create_cell("SAW")
saw_cell.shapes(saw_layer).insert(RBA::Box::new(-40000,0,0,500000))
saw_cell.shapes(saw_layer).insert(RBA::Box::new(-40000,-40000,500000,0))
saw_cell.shapes(saw_layer).insert(RBA::Box::new(chip_length,chip_length,chip_length-500000,chip_length+40000))
saw_cell.shapes(saw_layer).insert(RBA::Box::new(chip_length,chip_length+40000,chip_length+40000,chip_length-500000))

cell1.insert(saw_cell.ref)

marker_width=20000
marker_length=200000
offsetM=200000
marker_cell= marker(marker_width, marker_length, "MARKER",silicon_layer,layout)
marker_ref=marker_cell.ref
marker_ref.na=2
marker_ref.nb=2
marker_ref.trans=RBA::Trans::new(0,offsetM,offsetM)
marker_ref.a=RBA::Point::new(0,chip_length-offsetM-1.2*marker_length - marker_width)
marker_ref.b=RBA::Point::new(chip_length-offsetM-1.2*marker_length - marker_width,0)
cell1.insert(marker_ref)
marker_cell= marker(marker_width, marker_length, "MARKER",dimple_layer,layout)
marker_ref.cell_index=marker_cell.cell_index
marker_ref.na=1
marker_ref.nb=2
marker_ref.trans=RBA::Trans::new(0,offsetM+marker_length*2,offsetM)
marker_ref.b=RBA::Point::new(chip_length-offsetM-5.5*marker_length,0)
cell1.insert(marker_ref)

gap=bridge_gap=23000
gap=17000
strip_width=9000
bond_shift=5000
bond_length=700000
strip_length=chip_length-2020000

t1 = RBA::CplxTrans::new(1, 0, false, bond_length*1.4 ,chip_length-bond_length*1)
t2 = RBA::CplxTrans::new(1, -90, false, chip_length-bond_length , chip_length-bond_length*3+1E5)
t3 = RBA::CplxTrans::new(1, 90, false, chip_length-bond_length , bond_length*1.5+1E5)
t4 = RBA::CplxTrans::new(1, 180, false, chip_length-bond_length*1.5 , chip_length-bond_length)
bond_cell = layout.create_cell("BOND")
bond_poly=bond(silicon_layer,bond_cell,strip_width,bond_shift) #creates bond and returns polygon
bond_ref=RBA::CellInstArray::new(bond_cell.cell_index,t2)
bond_ref2=RBA::CellInstArray::new(bond_cell.cell_index,t1)
bond_ref3=RBA::CellInstArray::new(bond_cell.cell_index,t3)
bond_ref4=RBA::CellInstArray::new(bond_cell.cell_index,t4)
cell1.insert(bond_ref)
cell1.insert(bond_ref2)
cell1.insert(bond_ref3)
cell1.insert(bond_ref4)

cpw_cell = layout.create_cell("CPW")
waveguide(silicon_layer,cpw_cell,"(0,0; #{strip_length},0)",strip_width,gap)
cpw_ref=cpw_cell.ref
cpw_ref.trans=RBA::Trans::new(bond_length*1.395,chip_length-bond_length*1)
cell1.insert(cpw_ref)

strip_length2=strip_length-1120000
cpw2_cell = layout.create_cell("CPW2")
waveguide(silicon_layer,cpw2_cell,"(0,0; #{strip_length2},0)",strip_width,gap)
cpw2_ref=cpw2_cell.ref
cpw2_ref.trans=RBA::Trans::new(RBA::Trans::R270,chip_length-bond_length, chip_length-bond_length*2.995+1E5)
cell1.insert(cpw2_ref)

res_cell = layout.create_cell("RES")
waveguide(silicon_layer,res_cell,"(0,0; #{5004000},0)",strip_width,gap)
res_cell.shapes(silicon_layer).insert(RBA::Box::new(0,-gap/2,4000,gap/2))
res_ref=res_cell.ref
res_ref.trans=RBA::Trans::new(RBA::Trans::R270,bond_length*2.5, chip_length-bond_length-15.5E3)
res_ref.a=RBA::Point::new(bond_length,0)
res_ref.b=RBA::Point::new(0,100000)
res_ref.na=4
cell1.insert(res_ref)

bridge_dummy=layout.create_cell("DUMMY")
res_bridge = layout.create_cell("RESBRDG")
res_bridge.shapes(dimple_layer).insert(RBA::Box::new(17000, 12000+bridge_gap, 0, bridge_gap))
res_bridge.shapes(dimple_layer).insert(RBA::Box::new(17000, -12000, 0, 0))
bridge_dummy.shapes(bridge_layer).insert(RBA::Box::new((17-9)/2*1000,-8000,(17+9)/2*1000,bridge_gap+8000))
resB_ref=res_bridge.ref
resB_ref.trans=RBA::Trans::new(RBA::Trans::R270,bond_length*2.5-bridge_gap/2, chip_length-bond_length-19E3)
resB_ref.a=RBA::Point::new(0,-50000)
resB_ref.na=33
cell1.insert(resB_ref)
bridged_ref=resB_ref.dup
bridged_ref.cell_index=bridge_dummy.cell_index
dummy_cell.insert(bridged_ref)


resB_ref.trans=RBA::Trans::new(RBA::Trans::R270,bond_length*3.5-bridge_gap/2, chip_length-bond_length-19E3)
resB_ref.na=66
cell1.insert(resB_ref)
bridged_ref.trans=RBA::Trans::new(RBA::Trans::R270,bond_length*3.5-bridge_gap/2, chip_length-bond_length-19E3)
bridged_ref.na=66
dummy_cell.insert(bridged_ref)

bridged_ref.trans=resB_ref.trans=RBA::Trans::new(RBA::Trans::R270,bond_length*4.5-bridge_gap/2, chip_length-bond_length-19E3)
bridged_ref.na=resB_ref.na=100
cell1.insert(resB_ref)
dummy_cell.insert(bridged_ref)




x_shift=300000


dimp_cell = layout.create_cell("VIA")
#Here the gap is being chosen for the dimples from the ground plane. Getting too close might cause a short
dimp_cell.shapes(dimple_layer).insert(RBA::Box::new(-14000, -gap/2-2000, 0, gap/2+2000))
dimp_cell.shapes(dimple_layer).insert(RBA::Box::new(bridge_gap+14000, -gap/2-2000, bridge_gap, gap/2+2000))
dimple_ref=dimp_cell.ref
dimple_ref.a=RBA::Point::new(100000,0)
dimple_ref.b=RBA::Point::new(0,100000)
dimple_ref.cell_index=dimp_cell.cell_index
dimple_ref.trans=RBA::Trans::new(x_shift,600000)
dimple_ref.nb=40
dimple_ref.na=10
cell1.insert(dimple_ref)

#These are bite out holes from the CPW for testing bridge conductivity.
gap_cell = layout.create_cell("GAP")
gap_cell.shapes(silicon_layer).insert(RBA::Box::new(0, 0, gap, bridge_gap))
gap_cell.shapes(dimple_layer).insert(RBA::Box::new(17000, 14000+bridge_gap, 0, bridge_gap))
gap_cell.shapes(dimple_layer).insert(RBA::Box::new(17000, -14000, 0, 0))
gap_ref=gap_cell.ref
gap_ref.a=RBA::Point::new(10000,0)
gap_ref.b=RBA::Point::new(0,-100000)
gap_ref.nb=20
gap_ref.trans=RBA::Trans::new(0,chip_length-bond_length-gap/2, chip_length-bond_length*4)
cell1.insert(gap_ref)



bridge_cell.shapes(bridge_layer).insert(RBA::Box::new(-8000, -gap/2+4000, bridge_gap+8000, gap/2-4000))
#bridgeB.move(x_shift,600000)
bridge_ref=bridge_cell.ref
bridge_ref.a=RBA::Point::new(100000,0)
bridge_ref.b=RBA::Point::new(0,100000)
bridge_ref.cell_index=bridge_cell.cell_index
bridge_ref.trans=RBA::Trans::new(x_shift,600000)
bridge_ref.nb=40
bridge_ref.na=10
dummy_cell.insert(bridge_ref)

bridge_CPW=layout.create_cell("BRIDGECPW")
bridge_CPW.shapes(bridge_layer).insert(RBA::Box::new(0,-8000,9000,bridge_gap+8000))
bridge_CPWR=bridge_CPW.ref
bridge_CPWR.a=RBA::Point::new(10000,0)
bridge_CPWR.b=RBA::Point::new(0,-100000)
bridge_CPWR.na=1
bridge_CPWR.nb=20
bridge_CPWR.trans=RBA::Trans::new(0,chip_length-bond_length-4500, chip_length-bond_length*4)
dummy_cell.insert(bridge_CPWR)


shapeP=RBA::ShapeProcessor::new
bridge_shape_array=Array.new
dummy_cell.flatten(true)
dummy_cell.each_shape(bridge_layer) { |i|  bridge_shape_array<<(i) }
bridgesPoly= shapeP.merge_to_polygon(bridge_shape_array,0,true,true)

#Stupid laser writer software can't handle large polygons (more than ~36000 characters)

bridges_cell = layout.create_cell("BRIDGES")

ep=RBA::EdgeProcessor::new
outP = ep.boolean_p2p(bridgesPoly,[RBA::Polygon::new(RBA::Box::new(0,0,chip_length,chip_length/3)),
RBA::Polygon::new(RBA::Box::new(0,chip_length/3+1,chip_length,2*chip_length/3)),
RBA::Polygon::new(RBA::Box::new(0,2*chip_length/3+1,chip_length,chip_length))], RBA::EdgeProcessor::ModeXor, false, true)
outP.each { |i|  bridges_cell.shapes(bridge_layer).insert(i) }
dummy_cell.delete
bridges_ref=bridges_cell.ref
#bridge_ref.trans=RBA::Trans::new(strip_length+x_shift-50,6000)
cell1.insert(bridges_ref)
cell1_ref=cell1.ref
cell1_ref.na=2
cell1_ref.nb=2
cell1_ref.a=RBA::Point::new(chip_length+80000,0)
cell1_ref.b=RBA::Point::new(0,chip_length+80000)

topcell = layout.create_cell("TOPARRAY")
topcell.insert(cell1_ref)

view.select_cell(topcell.cell_index, 0)
view.show_all_cells
#layout.delete_layer(metal_layer)
view.add_missing_layers

#Some extra shapes added for guiding the cutting of the chip,
#visually inspecting the progress of aluminum acid etching and orientation
#borders
#cell1.shapes(silicon_layer).insert(RBA::Box::new(-100000,0,0,chip_length))
#cell1.shapes(silicon_layer).insert(RBA::Box::new(chip_length,0,chip_length+100000,chip_length))
#cell1.shapes(silicon_layer).insert(RBA::Box::new(-100000,-100000,chip_length+100000,0))
#cell1.shapes(silicon_layer).insert(RBA::Box::new(-100000,chip_length ,chip_length+100000,chip_length+100000))

#This side up triangle
#triY=2700000
#cell1.shapes(silicon_layer).insert(RBA::Polygon::from_s("(#{chip_length/2},#{chip_length/2+triY};#{chip_length/2-400000},\
##{chip_length/2-400000+triY};#{chip_length/2+400000},#{chip_length/2-400000+triY})"))
